#ifndef X11_With_Color
#define X11_With_Color

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <jpeglib.h>

/* here are our X variables */
static Display *dis;				// Display screen, visual etc are used for X server ...
static int screen,depth;			// check out http://neuraldk.org/document.php?xintro for some explanation 
static Window win;
static Visual *visual;
static XEvent event;
static XSizeHints hint;
static XVisualInfo visual_info, *visual_list;
static XWindowAttributes attributes;
static XSetWindowAttributes setattributes;
static GC gc;
static KeySym key;         			/* handles KeyPress Events */   
static char text[255];    			 /* a char buffer for KeyPress Events and strings in the X window*/

// Drawing the grid as an X image
static XImage *planeimage;
static XImage *barimage;
static char *imagedata;

// Colours
static Colormap cmap;
static XColor *colors;
static unsigned long white, black, foreground, background;
static int UserCol[256][4]; // Array of 256 arrays of id,r,g,b

/* here are our X routines declared! */
void Initialize_X(int, int, int, int);
void Close_X();
void Redraw();
void Create_Colormap();
void ColorRGB();
int Write_Jpeg(XImage *img, const char* filename);

/* Grid functions */
void InitializeGrid(int,int);
void DisplayGrid(int);
void DrawBar(float);
void CatchEvents();

extern int** MyGrid; // 2D Array of ints 0-255

#endif
