#include <stdio.h>
#include <math.h>

double min(double, double), max(double, double), sign(double, double), heaviside(double);
const int nvar = 2;
const int nexpr = 0;
const int npar = 5;
const int nnames = 7;
double all_values[7];
double * const par_values = all_values + 2;
const char *all_names[7] = {"X","Y","dx","dy","rx","ry","vol"};
extern int positive_opt, forward_opt;
int jacob_opt = 1;

int Initialize(int, char**);
int mkVarPos(double[]);
int GrindMainLoop(int);

int mine(int argc, char *argv[])
{
  int i;
  for (i=0; i < argc; i++)
    printf("%s" ,argv[i]);
  return argc;
}

void fcn(double _x_[], double _dx_[])
{
double X_,Y_,dx_,dy_,rx_,ry_,vol_;
int _i_;
if (positive_opt) mkVarPos(_x_);
X_ = _x_[0];
Y_ = _x_[1];
dx_ = par_values[0];
dy_ = par_values[1];
rx_ = par_values[2];
ry_ = par_values[3];
vol_ = par_values[4];
_dx_[0]=((((rx_*X_)*((vol_-X_)-Y_))/vol_)-(dx_*X_));
_dx_[1]=((((ry_*Y_)*((vol_-X_)-Y_))/vol_)-(dy_*Y_));
if (!forward_opt)
  for (_i_=0; _i_<2; _i_++)
    _dx_[_i_] = - _dx_[_i_];
}

void jac(double _x_[], double _jac_[])
{
double X_,Y_,dx_,dy_,rx_,ry_,vol_;
int _i_;
X_ = _x_[0];
Y_ = _x_[1];
dx_ = par_values[0];
dy_ = par_values[1];
rx_ = par_values[2];
ry_ = par_values[3];
vol_ = par_values[4];
_jac_[0] = (((((rx_*((vol_-X_)-Y_))+((rx_*X_)*(0.-1.)))*vol_)/(vol_*vol_))-dx_);
_jac_[1] = ((((rx_*X_)*(0.-1.))*vol_)/(vol_*vol_));
_jac_[2] = ((((ry_*Y_)*(0.-1.))*vol_)/(vol_*vol_));
_jac_[3] = (((((ry_*((vol_-X_)-Y_))+((ry_*Y_)*(0.-1.)))*vol_)/(vol_*vol_))-dy_);
if (!forward_opt)
  for (_i_=0; _i_<4; _i_++)
    _jac_[_i_] = - _jac_[_i_];
}

int main(int argc, char *argv[])
{
  jacob_opt = 1;
  Initialize(argc, argv);
  GrindMainLoop(1);
  return 0;
}

